
/******************************************************************************
* MODULE     : keyw_continue.cc
* DESCRIPTION: The 'continue' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_continue_1 () {
  CHECK_SYNC (MMX_CONTINUE);
  // INPUT: (continue_1, cont, ...)
  if (env->contains (CONT_BREAK)) {
    list l= as_list (env [CONT_BREAK]);
    // CONTINUATION: (loop_env, loop_trace, old_cont, ...)
    trace= as_list (cadr (l));
    change_env (as_gentable (car (l)));
    cur= KW_LOOP_4;
    rem= cons (car(trace)[1], cddr (l));
    // OUTPUT: (loop_4, cond_list, old_cont, ...)
    FAST_CONTINUE (kw_loop_4);
  }
  else error (car(trace), "Not inside a loop");
}

} // namespace mmx
