
/******************************************************************************
* MODULE     : keyw_generate.cc
* DESCRIPTION: The 'generate' keyword
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <alias.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_generate_1 () {
  CHECK_SYNC (MMX_GENERATE);
  evaluate_arg (list (MMX_TRANSTYPE, car(trace)[1], VAL_CLASS), KW_GENERATE_2);
}

void
evaluator_rep::kw_generate_2 () {
  CHECK_SYNC (MMX_GENERATE);
  // INPUT: (generate_2, type, cont, ...)
  table ext;
  xtable  gen_env (env, ext);
  generic gval= list (gen_env, list (), car(trace)[2], KW_GENERATE_3);
  list    gl  = list (gval);
  generic gen = alias (car (gl));
  generic type= list (ID_GENERATOR, V (car (rem)));
  ext (MISC_GENERATE)= gen;
  ext (MISC_YIELD)= car (rem);
  cur= cadr (rem);
  rem= cons (value (gen, type), cddr (rem));
  // OUTPUT: (cont, generator, ...)
  trace= cdr (trace);
}

void
evaluator_rep::kw_generate_3 () {
  // INPUT: (generate_3, ret_val)
  if (env->contains (MISC_GENERATE)) {
    as_genalias (env [MISC_GENERATE]) -> set (list ());
    // CONTINUATION for next generation: ()
  }
  else { error (car(trace), "Not inside a generate"); return; }

  if (env->contains (CONT_YIELD)) {
    list l= as_list (env [CONT_YIELD]);
    // CONTINUATION: (old_env, old_trace, old_cont, ...)
    change_env (as_gentable (car (l)));
    cur= caddr (l);
    rem= cons (VAL_DONE, cdddr (l));
    // OUTPUT: (old_cont, ret_val, ...)
    trace= as_list (cadr (l));
  }
  else error (car(trace), "Not inside a generate");
}

} // namespace mmx
