
/******************************************************************************
* MODULE     : lib_print_class.cc
* DESCRIPTION: Printing classes
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <printer.hh>
namespace mmx {

void
evaluator_rep::lib_print_class_1 () {
  CHECK_SYNC (MMX_PRINT_CLASS);
  // Input: (print_class_1, arg, cont, ...)
  list    ret= cdr (as_list (car (rem)));
  printer out= as_printer (car (ret));
  generic cl = cadr (ret);
  if (is_mirror (cl) || is_symbol (cl)) {
    out->out << cl;
    cur= value (out, ID_OSTREAM);
    rem= cdr (rem);
    // Output: (out, cont, ...)
    trace= cdr (trace);
  }
  else if (is_list (cl)) {
    list l= as_list (cl);
    out->out << "(" << car (l);
    cur= LIB_PRINT_CLASS_2;
    rem= cons (out, cdr (l), cdr (rem));
    // Output: (print_class_2, out, args, cont, ...)
    lib_print_class_2 ();
  }
  else {
    out->out << "?";
    cur= value (out, ID_OSTREAM);
    rem= cdr (rem);
    // Output: (cont, out, ...)
    trace= cdr (trace);
  }
}

void
evaluator_rep::lib_print_class_2 () {
  CHECK_SYNC (MMX_PRINT_CLASS);
  // Input: (print_class_2, out, args, cont, ...)
  printer out= as_printer (car (rem));
  list    l  = as_list (cadr (rem));
  if (nil (l)) {
    out->out << ")";
    cur= value (out, ID_OSTREAM);
    rem= cddr (rem);
    // Output: (cont, out, ...)
    trace= cdr (trace);
  }
  else {
    out->out << " ";
    generic x= car (l);
    if (!is_value (x)) x= value (x, ID_CLASS);
    cur= list (MMX_LESSLESS_STR, value (out, ID_OSTREAM), x);
    rem= cons (LIB_PRINT_CLASS_3, out, cdr (l), cddr (rem));
    // Output: (instr, print_class_3, out, args, cont, ...)
  }
}

void
evaluator_rep::lib_print_class_3 () {
  CHECK_SYNC (MMX_PRINT_CLASS);
  // Input: (print_class_3, ret, out, args, cont, ...)
  cur= LIB_PRINT_CLASS_2;
  rem= cdr (rem);
  lib_print_class_2 ();
}

} // namespace mmx
